/*
 Photo Wizard
 A batch image convertor that performs simple image processing tasks.
 Copyright  2004, Manas Tungare.
 --------------------------------------------------------------------------
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace Org.ManasTungare.PhotoWizard.Operations
{
	/// <summary>
	/// Add a border as indicated via the parameters passed to it.
	/// </summary>
	public class Borderer : System.Windows.Forms.UserControl, Org.ManasTungare.PhotoWizard.IOperation
	{
		private System.Windows.Forms.TextBox widthTextBox;
		private System.Windows.Forms.TextBox heightTextBox;
		private System.Windows.Forms.Label widthLabel;
		private System.Windows.Forms.Label heightLabel;
		private System.Windows.Forms.CheckBox enableBorderCheckBox;
		private System.Windows.Forms.GroupBox bordererGroupBox;
		private System.Windows.Forms.PictureBox outsidePictureBox;
		private System.Windows.Forms.Button chooseColorButton;
		private System.Windows.Forms.PictureBox pictureBox1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Borderer()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Borderer));
			this.enableBorderCheckBox = new System.Windows.Forms.CheckBox();
			this.widthLabel = new System.Windows.Forms.Label();
			this.heightLabel = new System.Windows.Forms.Label();
			this.widthTextBox = new System.Windows.Forms.TextBox();
			this.heightTextBox = new System.Windows.Forms.TextBox();
			this.bordererGroupBox = new System.Windows.Forms.GroupBox();
			this.chooseColorButton = new System.Windows.Forms.Button();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.outsidePictureBox = new System.Windows.Forms.PictureBox();
			this.bordererGroupBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// enableBorderCheckBox
			// 
			this.enableBorderCheckBox.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.enableBorderCheckBox.Location = new System.Drawing.Point(16, 16);
			this.enableBorderCheckBox.Name = "enableBorderCheckBox";
			this.enableBorderCheckBox.Size = new System.Drawing.Size(112, 24);
			this.enableBorderCheckBox.TabIndex = 0;
			this.enableBorderCheckBox.Text = "Add Border";
			this.enableBorderCheckBox.CheckedChanged += new System.EventHandler(this.enableResizingCheckBox_CheckedChanged);
			// 
			// widthLabel
			// 
			this.widthLabel.AutoSize = true;
			this.widthLabel.Enabled = false;
			this.widthLabel.Location = new System.Drawing.Point(80, 44);
			this.widthLabel.Name = "widthLabel";
			this.widthLabel.Size = new System.Drawing.Size(37, 17);
			this.widthLabel.TabIndex = 1;
			this.widthLabel.Text = "Width:";
			// 
			// heightLabel
			// 
			this.heightLabel.AutoSize = true;
			this.heightLabel.BackColor = System.Drawing.Color.Transparent;
			this.heightLabel.Enabled = false;
			this.heightLabel.Location = new System.Drawing.Point(16, 80);
			this.heightLabel.Name = "heightLabel";
			this.heightLabel.Size = new System.Drawing.Size(41, 17);
			this.heightLabel.TabIndex = 2;
			this.heightLabel.Text = "Height:";
			// 
			// widthTextBox
			// 
			this.widthTextBox.Enabled = false;
			this.widthTextBox.Location = new System.Drawing.Point(120, 40);
			this.widthTextBox.Name = "widthTextBox";
			this.widthTextBox.Size = new System.Drawing.Size(64, 21);
			this.widthTextBox.TabIndex = 3;
			this.widthTextBox.Text = "1";
			this.widthTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// heightTextBox
			// 
			this.heightTextBox.Enabled = false;
			this.heightTextBox.Location = new System.Drawing.Point(16, 96);
			this.heightTextBox.Name = "heightTextBox";
			this.heightTextBox.Size = new System.Drawing.Size(64, 21);
			this.heightTextBox.TabIndex = 4;
			this.heightTextBox.Text = "1";
			this.heightTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// bordererGroupBox
			// 
			this.bordererGroupBox.Controls.Add(this.heightTextBox);
			this.bordererGroupBox.Controls.Add(this.heightLabel);
			this.bordererGroupBox.Controls.Add(this.widthLabel);
			this.bordererGroupBox.Controls.Add(this.widthTextBox);
			this.bordererGroupBox.Controls.Add(this.enableBorderCheckBox);
			this.bordererGroupBox.Controls.Add(this.chooseColorButton);
			this.bordererGroupBox.Controls.Add(this.pictureBox1);
			this.bordererGroupBox.Controls.Add(this.outsidePictureBox);
			this.bordererGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.bordererGroupBox.Location = new System.Drawing.Point(0, 0);
			this.bordererGroupBox.Name = "bordererGroupBox";
			this.bordererGroupBox.Size = new System.Drawing.Size(240, 168);
			this.bordererGroupBox.TabIndex = 6;
			this.bordererGroupBox.TabStop = false;
			// 
			// chooseColorButton
			// 
			this.chooseColorButton.Enabled = false;
			this.chooseColorButton.Location = new System.Drawing.Point(120, 96);
			this.chooseColorButton.Name = "chooseColorButton";
			this.chooseColorButton.Size = new System.Drawing.Size(64, 23);
			this.chooseColorButton.TabIndex = 7;
			this.chooseColorButton.Text = "Color";
			this.chooseColorButton.Click += new System.EventHandler(this.chooseColorButton_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(96, 72);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(112, 72);
			this.pictureBox1.TabIndex = 8;
			this.pictureBox1.TabStop = false;
			// 
			// outsidePictureBox
			// 
			this.outsidePictureBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.outsidePictureBox.Location = new System.Drawing.Point(88, 64);
			this.outsidePictureBox.Name = "outsidePictureBox";
			this.outsidePictureBox.Size = new System.Drawing.Size(128, 88);
			this.outsidePictureBox.TabIndex = 7;
			this.outsidePictureBox.TabStop = false;
			// 
			// Borderer
			// 
			this.AutoScroll = true;
			this.AutoScrollMargin = new System.Drawing.Size(4, 4);
			this.AutoScrollMinSize = new System.Drawing.Size(232, 162);
			this.Controls.Add(this.bordererGroupBox);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "Borderer";
			this.Size = new System.Drawing.Size(240, 168);
			this.bordererGroupBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void enableResizingCheckBox_CheckedChanged(object sender, System.EventArgs e)
		{
			bool enableEverything = this.enableBorderCheckBox.Checked;
			foreach (Control control in this.bordererGroupBox.Controls ) 
			{
				control.Enabled = enableEverything;
				foreach (Control child in control.Controls )
				{
					child.Enabled = enableEverything;
				}
			}
			this.enableBorderCheckBox.Enabled = true;
		}

		private void chooseColorButton_Click(object sender, System.EventArgs e)
		{
			ColorDialog colorChooserDialog = new ColorDialog();
			colorChooserDialog.ShowDialog();
			this.outsidePictureBox.BackColor = colorChooserDialog.Color;
		}

		public string getImageMagickCommand() 
		{
			return this.enableBorderCheckBox.Checked 
				? 
				"-border " + this.widthTextBox.Text.Trim() + "x" + this.heightTextBox.Text.Trim() + 
				" -bordercolor " + toHexColor(this.outsidePictureBox.BackColor) 
				: 
				"";
		}

		private string toHexColor(Color rgb) 
		{
			return "#" + String.Format("{0:x2}", rgb.R) + 
				         String.Format("{0:x2}", rgb.G) + 
				         String.Format("{0:x2}", rgb.B);
		}
	}
}
